#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Tabs.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Button.H>
#include <stdio.h>
#include <string.h>
//
// Initialize a dialog with a particular input selected
//
class Dialog : public Fl_Group {
     Fl_Input *a,*b,*c;
public:
     Dialog(int X,int Y,int W,int H,const char *title):Fl_Group(X,Y,W,H,title) {
         begin();
         {
             char s[80];
             X += 100; Y += 10; W -= 110; H = 28;        // offset inputs within group
             sprintf(s, "%s 1", title); a = new Fl_Input(X,Y,W,H,strdup(s)); a->value("111 stuff"); Y += 40;
             sprintf(s, "%s 2", title); b = new Fl_Input(X,Y,W,H,strdup(s)); b->value("222 stuff"); Y += 40;
             sprintf(s, "%s 3", title); c = new Fl_Input(X,Y,W,H,strdup(s)); c->value("333 stuff"); Y += 40;
         }
         end();
         // ** FORCE SECOND WIDGET TO TAKE FOCUS, AND SELECT TEXT **
         b->take_focus();
         b->position(strlen(b->value()), 0);
     }
};
class PrefsDialog : public Fl_Window {
     Fl_Tabs   *tabs;            // tabs area
     Dialog    *abc, *def;       // dialogs within tabs
     Fl_Button *ok;              // ok button
public:
     PrefsDialog(int W,int H, const char *l) : Fl_Window(W,H,l) {
         int X=0, Y=0;
         begin();
         {
             X += 10; Y += 10; W -= 20; H -= 60;         // offset tab area within window
             tabs = new Fl_Tabs(X,Y,W,H);
             tabs->begin();
             {
                 X += 10; Y += 30; W -= 20; H -= 40;     // offset dialogs with tabs
                 abc = new Dialog(X,Y,W,H,"ABC");        // tab 'ABC' -- dialog #1
                 def = new Dialog(X,Y,W,H,"DEF");        // tab 'DEF' -- dialog #2
             }
             tabs->end();
             X = (x()+w()-110); Y=(y()+h()-40); W=100; H=28;
             ok = new Fl_Button(X,Y,W,H,"OK");
         }
         end();
     }
};
/// MAIN
int main() {
     PrefsDialog prefs(720,486,"Foo");
     prefs.resizable(prefs);
     prefs.show();
     return(Fl::run());
}

